   .586
.mmx
.xmm

.model flat,stdcall
option casemap:none


literal_string		macro	lit_string
			local	local_string

			.data
			align	4
local_string		db	lit_string, 0

			.code
			exitm	<local_string>
			endm
CADD MACRO quoted_text
      LOCAL vname,lbl
        jmp lbl
          vname db quoted_text,0
        lbl:
      EXITM <ADDR vname>
    ENDM
CSTR			macro	lit_string
			exitm	<offset literal_string(lit_string)>
			endm
literal_double		macro	lit_double:vararg
			local	local_double

			.data
local_double		real8	lit_double

			.code
			exitm	<local_double>
			endm
			
literal_float		MACRO	lit_float:VARARG
			LOCAL	local_float
			.data
local_float		real4	lit_float
			.code
			EXITM	<local_float>
			ENDM

CFLT			MACRO	lit_float:VARARG
			EXITM	<literal_float(lit_float)>
			ENDM
			
CTEXT MACRO y:VARARG
	LOCAL sym

	CONST segment
		IFIDNI <y>,<>
			sym db 0
		ELSE
			sym db y,0
		ENDIF
	CONST ends

	EXITM <OFFSET sym>
ENDM

CDBL			macro	lit_double:vararg
			exitm	<literal_double(lit_double)>
			endm
    include windows.inc
   include user32.inc
   include kernel32.inc
   include gdi32.inc
   include shell32.inc
   include comdlg32.inc
   include winmm.inc
   include ole32.inc
   include msvfw32.inc
   include avifil32.inc
   include  advapi32.inc
   include wininet.inc
   include avicap32.inc
   include gdiplus.inc
   include opengl32.inc
   include OpenGLUT.inc
   include glu.inc
   
  
   Include masm32.inc
   include macros.inc
   include graphics.inc
     include music.inc
  	include fFile.inc
  	 include additional.inc
   include hNullString.inc
   include mocap.inc
   include tga.inc
   include TriLoader.inc
   include 3D.inc

  
   includelib masm32.lib
   includelib gdi32.lib
   includelib user32.lib
   includelib kernel32.lib
   includelib winmm.lib
   includelib shell32.lib
	includelib	ole32.lib
	includelib advapi32.lib
	includelib msvfw32.lib
	includelib avifil32.lib
	includelib	oleaut32.lib
	includelib comdlg32.lib
	includelib wininet.lib
	includelib avicap32.lib
	includelib gdiplus.lib
	includelib opengl32.lib
	includelib glu32.lib
	includelib Graphics.lib
	
   
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
Draw proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

FPS_Count proto hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
     m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

.data
   ClassName db "GEF",0
   AppName  db "GEF-Game Engine",0
   
   Light_Position		real4	-0.0, 3.0, 3.5, 0.0
	Light_Diffuse		real4	1.0, 1.0, 1.0, 1.0
	Light_Ambient		real4	0.5, 0.5, 0.7, 1.0
	rot_o	real4 0.0
	
	posX real4 0.0
	posY real4 0.0
	posZ real4 0.0
	
	rotX real4 0.0
	rotY real4 0.0
	rotZ real4 0.0
.data?
	hInstance HINSTANCE ?
	CommandLine LPSTR ?
	hwnd dword ?
	mclick dword ?
	mclickup dword ?
	
	MOUSE POINT <?>
	dllhnd dword 0
	fb fBVH <0>
	
	hDC dword 0
	hRC dword 0
	o1 fTri <0>
	ft TGA <0>
	
	fps_cnt dword 0
	FPS dword 0
	base dword 0
.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX 
	LOCAL msg:MSG 
	
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,WS_OVERLAPPEDWINDOW\
           ,0,\
           0,600,480,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp


WndProc proc uses esi edi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL t[256]:dword
	LOCAL t2[256]:dword
	LOCAL buff[256]:dword
	LOCAL pic_pntr:dword
	LOCAL q:qword
	
	
	.IF uMsg==WM_DESTROY		
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		
		invoke GetSystemMetrics,SM_CXSCREEN
		cmp eax,600
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution width less than 600 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		
		invoke GetSystemMetrics,SM_CYSCREEN
		cmp eax,480
		jnl @f
			invoke MessageBox,hWnd,CADD("Resolution height less than 480 pixels"),CADD("Execution aborted"),MB_OK
			invoke PostQuitMessage,NULL
		@@:
		invoke LoadLibrary,CADD("RICHED32.DLL")
		.if eax!=0
			mov dllhnd,eax
		.else
			invoke PERR
		.endif

		invoke fCenterWindows,hWnd,600,480
		; Do not remove this
		
		invoke fBVHReadData,CADD("Untitled.bvh"),addr fb
		
		invoke fEnableOpenGL,hWnd,addr hDC,addr hRC
		invoke fReadTriFile,CADD("map.tri"),addr o1
		;invoke fReadTGA,CADD("lightmap.tga"),addr ft
		
		invoke fTriGetVertexData,addr o1,17
		fld [eax].fTriData.NormalX
		fstp q
		invoke FloatToStr2,q,addr buff
	;	invoke MessageBox,0,addr buff,0,0
		
		invoke InitKeyboard
	;	fld [eax].fTriData.PositionZ
	;	fstp q
	;	invoke FloatToStr2,q,addr buff
	;	invoke MessageBox,0,addr buff,0,0
		invoke InitKeyboard
		
	;	invoke glEnable,GL_LIGHTING
		invoke glGenLists,96
		mov base,eax
		invoke wglUseFontBitmaps,hDC,32,96,base
	
		invoke SetTimer,hWnd,1,25,addr Draw
		invoke SetTimer,0,1,1000,addr FPS_Count
		
	.elseif uMsg==WM_SIZE
		
	.elseif uMsg==WM_MOUSEMOVE
		mov eax,lParam
		movzx edx,ax
		mov MOUSE.x,edx
		shr eax,16
		movzx edx,ax
		mov MOUSE.y,edx	

	.elseif uMsg==WM_KEYUP
		invoke InputKeyboadFrb,wParam,0
	.elseif uMsg==WM_KEYDOWN
		invoke InputKeyboadFrb,wParam,1
	.elseif uMsg==WM_LBUTTONUP
		.if mclick==1
			;mov mclickup,0
		.endif
		mov mclick,0
		
	.elseif uMsg==WM_LBUTTONDOWN
		mov mclick,1
		mov mclickup,1
		
	;	invoke ReleaseCapture
	;	invoke SendMessage,hWnd,0A1h,2,0  ;  To make the window follow our mouse
	
	.elseif uMsg==MM_MCINOTIFY
		
	.elseif uMsg==WM_USER
			
			
	.elseif uMsg==WM_COMMAND
		
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	
	
	xor eax,eax
	ret
WndProc endp

glPrint proc uses esi lpText:dword,lpFltX:dword,lpFltY:dword
	
	invoke glPushMatrix
	invoke glLoadIdentity
	invoke glPushAttrib,GL_LIST_BIT
	invoke glRasterPos2f,lpFltX,lpFltY
	mov eax,base
	sub eax,32
	invoke glListBase,eax
	invoke lstrlen,lpText
	mov edx,eax
	invoke glCallLists,edx,GL_UNSIGNED_BYTE,lpText
	invoke glPopAttrib
	invoke glPopMatrix
	
	ret
glPrint endp

Draw proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL buff[256]:dword
	
	invoke glClearColor,CFLT(0.0),CFLT(0.0),CFLT(0.0),CFLT(0.0)
	invoke glClear,GL_COLOR_BUFFER_BIT
	invoke glClear,GL_DEPTH_BUFFER_BIT
	
	
	invoke glLoadIdentity
	
;	invoke glLightfv,GL_LIGHT0,GL_DIFFUSE,addr Light_Diffuse
;	invoke glLightfv,GL_LIGHT0,GL_AMBIENT,addr Light_Ambient
;	invoke glLightfv,GL_LIGHT0,GL_POSITION,addr Light_Position
;	invoke glEnable,GL_LIGHT0
	
	invoke IsPressed,"W"
	.if eax==1
	;	fld posZ
	;	push CFLT(0.1)
	;		fadd dword ptr[esp]
	;	pop eax
	;	fstp posZ
	fldpi
	fdiv CFLT(180.0)
	fmul rotY
	fsin
	fmul CFLT(0.1)
	fchs
	fadd posX
	fstp posX
	
	fldpi
	fdiv CFLT(180.0)
	fmul rotY
	fcos
	fmul CFLT(0.1)
	fadd posZ
	fstp posZ
	.endif
	
	invoke IsPressed,"S"
	.if eax==1
	;	fld posZ
	;	push CFLT(0.1)
	;		fsub dword ptr[esp]
	;	pop eax
	;	fstp posZ
	
	fldpi 
	fmul rotY
	fdiv CFLT(180.0)
	fsin
	fmul CFLT(0.1)
	fadd posX
	fstp posX
	
	fldpi
	fmul rotY
	fdiv CFLT(180.0)
	fcos
	fmul CFLT(0.1)
	fchs
	fadd posZ
	fstp posZ
	
	.endif
	
	invoke IsPressed,"A"
	.if eax==1
	;	fld posX
	;	push CFLT(0.1)
	;		fsub dword ptr[esp]
	;	pop eax
	;	fstp posX
	fld rotY
	push CFLT(1.0)
		fsub dword ptr[esp]
	pop eax
	fstp rotY
	.endif
	
	invoke IsPressed,"D"
	.if eax==1
	;	fld posX
	;	push CFLT(0.1)
	;		fadd dword ptr[esp]
	;	pop eax
	;	fstp posX
	
	fld rotY
	push CFLT(1.0)
		fadd dword ptr[esp]
	pop eax
	fstp rotY
	.endif
	invoke glEnable,GL_DEPTH_TEST
	
	@@:
	
	invoke gluPerspective,CDBL(45.0),CDBL(1.0),CDBL(1.0),CDBL(200.0)
	
	invoke glRotatef,rotX,CFLT(1.0),CFLT(0.0),CFLT(0.0)
	invoke glRotatef,rotY,CFLT(0.0),CFLT(1.0),CFLT(0.0)
	invoke glRotatef,rotZ,CFLT(0.0),CFLT(0.0),CFLT(1.0)
	
	invoke glTranslatef,posX,posY,posZ
	
	invoke glPushMatrix
	invoke glTranslatef,CFLT(0.0),CFLT(0.0),CFLT(-16.0)
	invoke glRotatef,CFLT(0.0),CFLT(1.0),CFLT(0.0),CFLT(0.0)
	invoke glRotatef,CFLT(0.0),CFLT(0.0),CFLT(1.0),CFLT(0.0)
	invoke fDrawTri,addr o1,GL_TRIANGLES
	invoke glPopMatrix
	
	fld rot_o
	fadd CFLT(1.0)
	fstp rot_o
	
	invoke glPushMatrix
;	invoke glTranslatef,CFLT(3.0),CFLT(0.0),CFLT(-6.0)
;	invoke fDrawTri,addr o1,GL_TRIANGLES
	invoke glPopMatrix
	
	invoke dw2a,FPS,addr buff
	invoke lstrcat,addr buff,CADD(" FPS")
	invoke glPrint,addr buff,CFLT(-1.0),CFLT(0.9)
	
	invoke SwapBuffers,hDC
	inc fps_cnt
	
	ret
Draw endp

FPS_Count proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	push fps_cnt
	pop FPS
	xor ecx,ecx
	mov fps_cnt,ecx
	
	ret
FPS_Count endp

end start